
DATA "   PETIT4SEND SWITCH"
DATA "2019/06/17 VER.1.1.0"
DATA "        REI SOFTWARE"
DATA ""
'////////////////////////////////////////////////
'USB TRANSMITTER FOR PETITCOM4
'PC->PETIT4
' BY USB KEYBOARD
' MAX 240BYTE/SEC
'PETIT4->PC
' SCREENSHOT 2BIT/PIXEL(226800BYTE/IMAGE)
'////////////////////////////////////////////////
'INITIALIZE
ACLS
DIM KEYCODE%[]=[ \
  4,5,6,7,8,9,10,11,12,13, \
  14,15,16,17,18,19,20,21,22,23, \
  24,25,26,27,28,29,30,31,32,33, \
  34,35,36,37,38,39,40,41,42,43, \
  44,45,46,47,48,49,50,51,52,54, \
  55,56,73,74,75,76,77,78,79,80, \
  81,82,84,85,86,87,88,89,90,91, \
  92,93,94,95,96,97,98,99,100,103, \
  104,105,106,107,108,109,110,111,112,113, \
  114,115,116,117,118,119,120,121,122,123, \
  124,125,126,127,128,129,133,134,135,137, \
  155,156,157,158,159,160,161,162,163,164, \
  176,177,178,179,180,181,182,183,184,185, \
  186,187,188,189,190,191,192,193,194,195, \
  196,197,198,199,200,201,202,203,204,205, \
  206,207,208,209,210,211,212,213,214,215, \
  216,217,218,219,220,221]
DIM P0%[]=[RGB(0,0,0),RGB(85,85,85),RGB(170,170,170),RGB(255,255,255)]
DIM CRCTBL%[]:CRCTBL%=CALC_CRCTBL()
VAR DUMMY%
DIM ML$[]

'SYNCKEY
DIM SB%[]
DIM SKT%[25]
VAR SK0%
'RECEIVE
VAR STATE%,STARTMS%,FILELEN%,FILENAME$,FILECRC%
VAR GRPW%,GRPH%
VAR CLK%,BCLK%,MK%,BMK%,D#,DL%,DH%
VAR FT$
DIM REC%[],RZC%[],RZC32%[],RFC%[],VK%[]
DIM FG%[],FI%[]
'SCREENSHOT
VAR HDS%,SCS%,TIMG%,IMG%,STLEN%,XORPTN%
DIM FL$[],HD%[]

LOOP
 READ MES$
 IF MES$=="" THEN BREAK
 INC TITLE$," "*(50-LEN(MES$))+MES$
ENDLOOP

'////////////////////////////////////////////////
@TITLE
WHILE INKEY$()!="" WEND
PRINTTITLE
PRINT "SELECT ACTION"

RESIZE ML$,0
PUSH ML$,"DETECT SYNC KEY"
PUSH ML$,"USB RECEIVE"
PUSH ML$,"SCREENSHOT SEND"
PUSH ML$,"EXIT"

ACTION%=SELECT(ML$,"",ACTION%)
IF ACTION%==0 THEN GOTO @SYNCKEY
IF ACTION%==1 THEN GOTO @USBRECEIVE
IF ACTION%==2 THEN GOTO @SCREENSHOT
END

'////////////////////////////////////////////////
@SYNCKEY
PRINTTITLE
PRINT "WAITING SYNC KEY..."

SK%=-1
SKT%=ARRAY%(25)
SB%=ARRAY%(0)
LOOP
 VSYNC
 IF BUTTON(0,#B_RDOWN,2) THEN @TITLE
 B%=-1
 FOR I%=0 TO 24
  IF KEYBOARD(I%+4) THEN B%=I%
 NEXT
 IF B%==-1 THEN SB%=ARRAY%(0):CONTINUE
 PUSH SB%,B%
 IF LEN(SB%)<12 THEN CONTINUE
 SORT SB%
 J%=2:SK0%=-1
 FOR I%=0 TO 12
   IF SB%[I% MOD 12]==J% THEN
     SK0%=(SB%[I% MOD 12]+1)MOD 25
     BREAK
   ENDIF
   J%=(SB%[I% MOD 12]+3)MOD 25
 NEXT
 SB%=ARRAY%(0)
 IF SK0%>=0 THEN INC SKT%[SK0%]
 J%=10:SK%=-1
 FOR I%=0 TO 24
   IF J%<SKT%[I%] THEN J%=SKT%[I%]:SK%=I%
 NEXT
 IF SK%>=0 THEN
  LOCATE 0,:PRINT "SYNC KEY:";
  COLOR #C_RED:PRINT SK%;:COLOR #C_WHITE
 ENDIF
ENDLOOP

'////////////////////////////////////////////////
@USBRECEIVE
PRINTTITLE
PRINT "WAITING FILE..."

PUSHKEY 65622 'CLEAR SOFT KEY
KEYBOARD 4 OUT DUMMY%,CLK%
CLK%=CLK% AND &H03

STATE%=0
REC%=ARRAY%(0)
RZC%=ARRAY%(0)
RFC%=ARRAY%(0)
CRC%=&HFFFF
ERRP%=0

LOOP
 GOSUB @RECEIVE
 CASE STATE%
 WHEN 0
  'START FLAG 4BYTE
  IF BUTTON(0,#B_RDOWN) THEN GOTO @TITLE
  IF LEN(REC%)<=0 THEN CONTINUE
  WHILE LEN(REC%)>0
   B%=SHIFT(REC%)
   IF B%==&H01 THEN BREAK
  WEND
  IF B%!=&H01 THEN CONTINUE
  STARTMS%=MILLISEC()
  PRINT "START TRANSFER"
  ERRP%=1 'ERROR PRINT ENABLE
  STATE%=1
 WHEN 1
  'FILE TYPE+NAME 4+32BYTE
  IF BUTTON(0,#B_RDOWN) THEN GOTO @TITLE
  IF LEN(REC%)<36 THEN CONTINUE
  FILENAME$=""
  FOR I%=0 TO 35
   IF REC%[I%]==0 THEN BREAK
   FILENAME$=FILENAME$+CHR$(REC%[I%])
  NEXT
  FOR I%=0 TO 35:DUMMY%=SHIFT(REC%):NEXT
  PRINT "FILENAME: ";FILENAME$
  STATE%=2:
 WHEN 2
  'FILE LENGTH 4BYTE
  IF BUTTON(0,#B_RDOWN) THEN GOTO @TITLE
  IF LEN(REC%)<4 THEN CONTINUE
  FILELEN%=SHIFT(REC%)
  FILELEN%=FILELEN%+(SHIFT(REC%)<<8)
  FILELEN%=FILELEN%+(SHIFT(REC%)<<16)
  FILELEN%=FILELEN%+(SHIFT(REC%)<<24)
  PRINT "FILELENGTH: ";FILELEN%
  STATE%=3
 WHEN 3
  'GRP SIZE 4BYTE
  IF BUTTON(0,#B_RDOWN) THEN GOTO @TITLE
  IF LEN(REC%)<4 THEN CONTINUE
  GRPW%=SHIFT(REC%):GRPW%=GRPW%+(SHIFT(REC%)<<8)
  GRPH%=SHIFT(REC%):GRPH%=GRPH%+(SHIFT(REC%)<<8)
  IF MID$(FILENAME$,0,4)=="GRP:" THEN
   PRINT "WIDTH: ";GRPW%
   PRINT "HEIGHT: ";GRPH%
  ENDIF
  STATE%=4
 WHEN 4
  'TRANSFER LENGTH 4BYTE
  IF BUTTON(0,#B_RDOWN) THEN GOTO @TITLE
  IF LEN(REC%)<4 THEN CONTINUE
  RTLEN%=SHIFT(REC%)
  RTLEN%=RTLEN%+(SHIFT(REC%)<<8)
  RTLEN%=RTLEN%+(SHIFT(REC%)<<16)
  RTLEN%=RTLEN%+(SHIFT(REC%)<<24)
  PRINT "TRANSFER LENGTH: ";RTLEN%
  PRINT "START"
  STATE%=5
 WHEN 5
  'FILE CONTENTS 4BYTE/RECEIVE
  IF BUTTON(0,#B_RDOWN) THEN GOTO @TITLE
  IF LEN(REC%)<=0 THEN CONTINUE
  WHILE LEN(REC%)>0
   PUSH RZC%,SHIFT(REC%)
   IF LEN(RZC%)>=RTLEN% THEN BREAK
  WEND
  LOCATE 0,
  DT#=LEN(RZC%)/(MILLISEC()-STARTMS%)*1000
  PRINT LEN(RZC%);" BYTES (";FORMAT$("%3.2F",DT#);" BYTES/SEC)";
  IF LEN(RZC%)>=RTLEN% THEN
   PRINT
   PRINT "COMPLETE"
   STATE%=6
  ENDIF
 WHEN 6
  'FILE CRC
  IF BUTTON(0,#B_RDOWN) THEN GOTO @TITLE
  IF LEN(REC%)<2 THEN CONTINUE
  FILECRC%=SHIFT(REC%)
  FILECRC%=FILECRC%+(SHIFT(REC%)<<8)
  ERRP%=0 'ERROR PRINT DISABLE
  BREAK
 ENDCASE
ENDLOOP

'DECOMPRESS
PRINT "DECOMPRESS..."
'MAKE 32BIT ARRAY
RZC32%=ARRAY%(0)
WHILE LEN(RZC%)MOD 4>0:PUSH RZC%,0:WEND
FOR I%=0 TO LEN(RZC%)-1 STEP 4
 D%=    RZC%[I%  ]
 D%=D%+(RZC%[I%+1]<< 8)
 D%=D%+(RZC%[I%+2]<<16)
 D%=D%+(RZC%[I%+3]<<24)
 PUSH RZC32%,D%
NEXT
RFC%=ARRAY%(0)
UNLZ RZC32%,0,RFC%,10,5,8,1

IF FILELEN%>LEN(RFC%) THEN
 COLOR #C_RED:PRINT "FILESIZE ERROR":COLOR #C_WHITE
 PRINT "FORCE SAVE? YES[A]/NO[B]"
 LOOP
  VSYNC
  IF BUTTON(0,#B_RRIGHT,1) THEN BREAK
  IF BUTTON(0,#B_RDOWN,1) THEN GOTO @TITLE
 ENDLOOP
ENDIF
RESIZE RFC%,FILELEN%

'CRC CHECK
CRC%=&HFFFF
FOR I%=0 TO FILELEN%-1
 CRC%=CALC_CRC(CRC%,CRCTBL%,RFC%[I%])
NEXT
CRC%=CRC% XOR &HFFFF

IF CRC%!=FILECRC% THEN
 COLOR #C_RED:PRINT "CRC ERROR":COLOR #C_WHITE
 PRINT "FORCE SAVE? YES[A]/NO[B]"
 LOOP
  VSYNC
  IF BUTTON(0,#B_RRIGHT,1) THEN BREAK
  IF BUTTON(0,#B_RDOWN,1) THEN GOTO @TITLE
 ENDLOOP
ENDIF

'SAVE
CASE MID$(FILENAME$,0,4)
WHEN "TXT:"
 FT$=""
 WHILE LEN(RFC%)MOD 2!=0:PUSH RFC%,0:WEND
 FOR I%=0 TO LEN(RFC%)-1 STEP 2
  PUSH FT$,CHR$(RFC%[I%]+(RFC%[I%+1]<<8))
 NEXT
 SAVEV FILENAME$,FT$
WHEN "GRP:"
 FG%=ARRAY%(GRPH%,GRPW%)
 X%=0:Y%=0
 WHILE LEN(RFC%)MOD 4!=0:PUSH RFC%,0:WEND
 FOR I%=0 TO LEN(RFC%)-1 STEP 4
  FG%[Y%,X%]=RFC%[I%]+(RFC%[I%+1]<<8)+(RFC%[I%+2]<<16)+(RFC%[I%+3]<<24)
  X%=X%+1:IF X%>=GRPW% THEN X%=0:Y%=Y%+1
 NEXT
 GLOAD 0,0,GRPW%,GRPH%,FG%,0
 WHILE BUTTON(0,-1,0)!=0:VSYNC:WEND
 WHILE BUTTON(0,-1,0)==0:VSYNC:WEND
 SAVEG FILENAME$,GTARGET(),0,0,GRPW%,GRPH%
 GCLS
WHEN "DAT:"
 FI%=ARRAY%(0)
 WHILE LEN(RFC%)MOD 4!=0:PUSH RFC%,0:WEND
 FOR I%=0 TO LEN(RFC%)-1 STEP 4
  PUSH FI%, RFC%[I%]+(RFC%[I%+1]<<8)+(RFC%[I%+2]<<16)+(RFC%[I%+3]<<24)
 NEXT
 SAVEV FILENAME$,FI%
OTHERWISE
 PRINT "UNKNOWN TYPE"
 SAVEV FILENAME$,RFC%
ENDCASE
GOTO @TITLE

END

'////////////////////////////////////////////////
@RECEIVE
'WAIT UPDATE
VSYNC
'CHECK CLOCK
KEYBOARD 4 OUT DUMMY%,MK%
IF MK% == BMK% THEN RETURN
'READ KEY
FOR I%=0 TO 154
 IF KEYBOARD(KEYCODE%[I%]) THEN PUSH VK%,I%
NEXT
'CHECK AND UPDATE CLOCK
BMK%=MK%
CLK%=(MK% AND 3)
IF BCLK%!=CLK% THEN
  IF ERRP% THEN 
   COLOR #C_RED:PRINT "LOOOSE PACKET(CLK)":COLOR #C_WHITE
 ENDIF
ENDIF
BCLK%=(CLK%+1)AND 3
'CHECK KEY
IF LEN(VK%)!=6 THEN
 IF ERRP% THEN 
  COLOR #C_RED:PRINT "LOOOSE PACKET(KEY)":COLOR #C_WHITE
 ENDIF
 RETURN
ENDIF
'MAKE HASH VALUE
SORT VK%
D#=   VK%[0]
D#=D#+VK%[1]*(VK%[1]-1)/2
D#=D#+VK%[2]*(VK%[2]-1)/2*(VK%[2]-2)/3
D#=D#+VK%[3]*(VK%[3]-1)/2*(VK%[3]-2)/3*(VK%[3]-3)/4
D#=D#+VK%[4]*(VK%[4]-1)/2*(VK%[4]-2)/3*(VK%[4]-3)/4*(VK%[4]-4)/5
D#=D#+VK%[5]*(VK%[5]-1)/2*(VK%[5]-2)/3*(VK%[5]-3)/4*(VK%[5]-4)/5*(VK%[5]-5)/6
DH%=INT(D#/256)
DL%=INT(D#-DH%*256.0)
VK%=ARRAY%(0)
'MAKE 8BIT VALUE AND PUSH IT TO BUFFER
PUSH REC%, DL%
PUSH REC%, DH%      AND &HFF
PUSH REC%, (DH%>> 8)AND &HFF
PUSH REC%, (DH%>>16)AND &HFF
'
IF (DH%>>24)!=0 THEN STOP'''''''''''''''''''''''
RETURN

'////////////////////////////////////////////////
@SCREENSHOT
PRINTTITLE
PRINT "SCREENSHOT SEND"
PRINT ""
PRINT "SELECT FILE"

FL$=FILES()
I%=SELECT(FL$,"NO FILE",0)
IF I%<0 THEN GOTO @TITLE
FILENAME$=FL$[I%]

PRINTTITLE
PRINT "SCREENSHOT SEND"
PRINT ""
PRINT "FILENAME:"+FILENAME$
PRINT "LOADING..."

'LOAD
RFC%=ARRAY%(0)
CASE MID$(FILENAME$,0,4)
WHEN "TXT:"
 FT$=LOADV(FILENAME$)
 FOR I%=0 TO LEN(FT$)-1
  PUSH RFC%, ASC(FT$[I%]) AND &HFF
  PUSH RFC%, ASC(FT$[I%]) >> 8
 NEXT
WHEN "GRP:"
 FG%=LOADV(FILENAME$)
 GRPW%=DIM(FG%,1):GRPH%=DIM(FG%,0)
 FOR Y%=0 TO GRPH%-1
  FOR X%=0 TO GRPW%-1
   PUSH RFC%,  FG%[Y%,X%]      AND &HFF
   PUSH RFC%, (FG%[Y%,X%]>> 8) AND &HFF
   PUSH RFC%, (FG%[Y%,X%]>>16) AND &HFF
   PUSH RFC%, (FG%[Y%,X%]>>24) AND &HFF
  NEXT
 NEXT
WHEN "DAT:"
 FI%=LOADV(FILENAME$)
 FOR I%=0 TO LEN(FI$)-1
  PUSH RFC%,  FI%[I%] AND &HFF
  PUSH RFC%, (FI%[I%]>> 8) AND &HFF
  PUSH RFC%, (FI%[I%]>>16) AND &HFF
  PUSH RFC%, (FI%[I%]>>24) AND &HFF
 NEXT
ENDCASE
PRINT "FILELENGTH:";LEN(RFC%)

'CALC CRC
CRC%=&HFFFF
FOR I%=0 TO LEN(RFC%)-1
 CRC%=CALC_CRC(CRC%,CRCTBL%,RFC%[I%])
NEXT
CRC%=CRC% XOR &HFFFF
PRINT "CRC:";HEX$(CRC%)

'LZ
PRINT "COMPRESSING..."
RZC%=ARRAY%(0)
LZ RFC%,RZC%,10,5,3,8,1
PRINT "TRANSFER LENGTH:";LEN(RZC%)

HDS%=14 ' 56 BYTES HEADER
SCS%=1280*720*2/8 'BYTES PER SCREEN
TIMG%=CEIL(LEN(RZC%)/(SCS%-HDS%*4)) ' TOTALIMAGES

PRINT "TOTAL "+STR$(TIMG%)+" IMAGES"
WHILE BUTTON(0,-1,0)!=0:VSYNC:WEND
WHILE BUTTON(0,-1,0)==0:VSYNC:WEND

'MAKE HEADER
HD%=ARRAY%(HDS%)
HD%[0]=&H505A5332 'PZS2
HD%[1]=LEN(RFC%)  'FILE SIZE
HD%[2]=CRC%       'CRC
FOR I%=0 TO LEN(FILENAME$)-1
 INC HD%[(I% DIV 4)+3],ASC(FILENAME$[I%])<<((I% MOD 4)*8)
NEXT
HD%[12]=TIMG% OR (IMG%<<8) OR (XORPTN%<<16)
HD%[13]=0

'DRAW
ACLS
XSCREEN 1280,720
J%=0:B%=0:P%=0:IMG%=0

@DRAWPAGE
GCLS
IF B%!=0 THEN ?"ERROR":STOP
X0%=0:Y0%=0
'UPDATE STREAM LENGTH AND IMG NUM
STLEN%=MIN(SCS%-HDS%*4,(LEN(RZC%)-J%)*4)


'FLUCTUATE PATTERN
XORPTN%=RND(&H100)*&H01010101
HD%[12]=TIMG% OR (IMG%<<8) OR (XORPTN%<<16)
HD%[13]=STLEN%
'HEADER
I%=0:B%=0:T%=0
LOOP
 IF B%==0 THEN
  IF I%<HDS% THEN
   T%=HD%[I%]
   B%=B%+32
   I%=I%+1
  ELSEIF J%<LEN(RZC%) THEN
   T%=RZC%[J%] XOR XORPTN%
   B%=B%+32
   J%=J%+1
  ELSE
   BREAK
  ENDIF
 ENDIF
 V%=T% AND &H3
 T%=T%>>2
 B%=B%-2
 GPSET X0%,Y0%,P0%[V%]
 X0%=X0%+1
 IF X0%>=1280 THEN
  X0%=0:Y0%=Y0%+1
  IF Y0%>=720 THEN
   Y0%=0:IMG%=IMG%+1
   'WAIT INPUT
   WHILE BUTTON(0,-1,0)!=0:VSYNC:WEND
   WHILE BUTTON(0,-1,0)==0:VSYNC:WEND
   GOTO @DRAWPAGE
  ENDIF
 ENDIF
ENDLOOP

WHILE BUTTON(0,-1,0)!=0:VSYNC:WEND
WHILE BUTTON(0,-1,0)==0:VSYNC:WEND
ACLS
GOTO @TITLE

'////////////////////////////////////////////////
DEF PRINTTITLE
 VAR MES$,TM%,CM%
 CLS
 COLOR #C_TEAL
 PRINT TITLE$:PRINT 
 FREEMEM OUT CM%, TM%
 MES$="FREE MEMORY:"+STR$(TM%)
 PRINT " "*(50-LEN(MES$))+MES$
 MES$="CONTIGUOUS MEMORY:"+STR$(CM%)
 PRINT " "*(50-LEN(MES$))+MES$
 COLOR #C_WHITE
END

DEF SELECT(L$[],NOMES$,INI%)
 LOCATE OUT CSRX,CSRY
 VAR CY%=CSRY+1
 VAR B%=BUTTON(1),SCNT%=-1
 VAR CI%=INI%,CI2%=0
 VAR I%,X#,Y#
 VAR IN$
 IF LEN(L$)==0 THEN
  LOCATE 0,CY%:COLOR #C_RED:PRINT NOMES$;
  COLOR #C_WHITE
  LOOP
   VSYNC 1
   IF BUTTON(0,-1,2) THEN RETURN -1
  ENDLOOP
 ENDIF
 WHILE CI%+CY%>=28:DEC CI%:INC CI2%:WEND
 LOOP
  LOCATE 0,CY%-1
  IF CI2%>0 THEN PRINT "" ELSE PRINT " "
  FOR I%=0 TO MIN(LEN(L$)-CI2%-1,28-CY%)
   IF I%==CI% THEN COLOR #C_RED
   PRINT L$[I%+CI2%];
   COLOR #C_WHITE
   LOCATE OUT CSRX,CSRY
   PRINT " "*(50-CSRX);
  NEXT
  FOR I%=I% TO 28-CY%
   PRINT " "*50;
  NEXT
  LOCATE 0,29
  IF LEN(L$)-CI2%-1>28-CY% THEN 
   PRINT "";
  ELSE
   PRINT " ";
  ENDIF
  LOOP
   VSYNC 1:B%=BUTTON(0,-1,1):IN$=INKEY$()
   IF IN$==CHR$(27) || B% AND (1<<#B_RDOWN) THEN RETURN -1
   IF IN$==CHR$(13) || B% AND (1<<#B_RRIGHT) THEN RETURN CI%+CI2%
   IF (IN$==CHR$(30) || B% AND (1<<#B_LUP)) && CI%+CI2%>0 THEN
    IF CI% >0 THEN DEC CI% ELSE DEC CI2%
    BREAK
   ENDIF
   IF (IN$==CHR$(31) || B% AND (1<<#B_LDOWN)) && CI%+CI2%+1<LEN(L$) THEN
    IF CI%+CY%<28 THEN INC CI% ELSE INC CI2%
    BREAK
   ENDIF
   STICK 0 OUT X#,Y#
   IF Y#>0.5 THEN
    IF MAINCNT()>SCNT% THEN
     IF SCNT%<0 THEN
      SCNT%=MAINCNT()+30
     ELSE
      SCNT%=MAINCNT()+3
     ENDIF
     CI2%=CI2%+(28-CY%)+1
     IF CI2%>LEN(L$)-1-(28-CY%) THEN
      CI2%=MAX(LEN(L$)-1-(28-CY%),0)
      CI%=MIN(28-CY%,LEN(L$)-1-CI2%)
     ENDIF
     BREAK
    ENDIF
   ELSEIF Y#<-0.5 THEN
    IF MAINCNT()>SCNT% THEN
     IF SCNT%<0 THEN
      SCNT%=MAINCNT()+30
     ELSE
      SCNT%=MAINCNT()+3
     ENDIF
     CI2%=CI2%-(28-CY%)-1
     IF CI2%<0 THEN
      CI2%=0
      CI%=0
     ENDIF
     BREAK
    ENDIF
   ELSE
    SCNT%=-1
   ENDIF
  ENDLOOP
 ENDLOOP
END

DEF LZ IN%[],OUT%[],WLB%,MLB%,MM%,BIT%,PROG%
 WLB%=MIN(MAX(WLB%,7),16)
 MLB%=MIN(MAX(MLB%,3),8)
 MM%=MIN(MAX(MM%,3),10)
 
 VAR WL%=(1<<WLB%)
 VAR WLM%=WL%-1
 VAR ML%=(1<<MLB%)-1
 VAR PH%,PL%,Q%,P%,P2%,OL%,O%
 VAR MD%,MP%,MLL%,D%,L%,B%,I%,DD%
 VAR LEN_IN% =LEN(IN%)
 VAR LEN_OUT%=LEN(IN%)*BIT%/8+ML%
 DIM BB%[WL%+ML%+1]
 DIM HS%[256],HL%[WL%]
 VAR H1%,H2%,HLI%=0
 VAR HS1%,HS2%,HS3%
 VAR CNT%=0,PRG1%
 
 FOR I%=0 TO 255:HS%[I%]=-1:NEXT
 PH%=0:PL%=0
 IF PH%<LEN_IN% THEN Q%=IN%[PH%] ELSE Q%=0
 P%=ML%
 FOR I%=0 TO ML%
  BB%[WL%+I%]=(Q%>>PL%) AND 255
  INC PL%,8:IF PL%>=BIT% THEN
   INC PH%:PL%=0
   IF PH%<LEN_IN% THEN Q%=IN%[PH%] ELSE Q%=0
  ENDIF
 NEXT
 HS1%=BB%[WL%]
 HS2%=BB%[WL%+1]
 HS3%=BB%[WL%+2]
 H1%=HS1% XOR HS2% XOR HS3%
 
 IF PROG% THEN
  PRG1%=P%*40/LEN_OUT%
  PRINT "*"*PRG1%+"-"*(40-PRG1%)
 ENDIF
 
 WHILE P%<LEN_OUT%
  IF PROG% THEN
   INC CNT%
   IF CNT%>16 THEN
    CNT%=0
    PRG1%=P%*40/LEN_OUT%
    LOCATE OUT CSRX,CSRY
    LOCATE 0,CSRY-1
    PRINT "*"*PRG1%+"-"*(40-PRG1%)
   ENDIF
  ENDIF
  
  MLL%=-1
  H2%=HS%[H1%]
  WHILE H2%>=0
   D%=(P%-ML%)-H2%
   IF D%>WL% THEN BREAK
   L%=1:P2%=WL%-D%
   WHILE P%+L%<LEN_OUT%
    IF BB%[P2%+L%]!=BB%[WL%+L%] THEN BREAK
    INC L%
    IF L%>ML% THEN MD%=D%:MLL%=L%:GOTO @LZ1
   WEND
   IF L%>MLL% THEN MD%=D%:MLL%=L%
   DEC H2%,HL%[H2% AND WLM%]
  WEND
  
  @LZ1
  IF MLL%<MM% THEN
   MLL%=1
   INC OL%
   IF OL%>=32 THEN
    PUSH OUT%,O%:O%=0:OL%=0
   ENDIF
   B%=HS1%'BB%[WL%]
   O%=O% OR (B%<<OL%)
   INC OL%,8
   IF OL%>=32 THEN
    PUSH OUT%,O%:DEC OL%,32
    O%=B%>>(8-OL%)
   ENDIF
  ELSE
   O%=O% OR (1<<OL%)
   INC OL%
   IF OL%>=32 THEN
    PUSH OUT%,O%:O%=0:OL%=0
   ENDIF
   B%=MD%-1
   O%=O% OR (B%<<OL%)
   INC OL%,WLB%
   IF OL%>=32 THEN
    PUSH OUT%,O%:DEC OL%,32
    O%=B%>>(WLB%-OL%)
   ENDIF
   B%=MLL%-1
   O%=O% OR (B%<<OL%)
   INC OL%,MLB%
   IF OL%>=32 THEN
    PUSH OUT%,O%:DEC OL%,32
    O%=B%>>(MLB%-OL%)
   ENDIF
  ENDIF
  I%=0
  REPEAT
   H2%=HS%[H1%]
   HS%[H1%]=P%-ML%
   HL%[HLI% AND WLM%]=HLI%-H2%
   INC HLI%
   B%=(Q%>>PL%) AND 255
   PUSH BB%,B%:B%=SHIFT(BB%)
   HS1%=HS2%:HS2%=HS3%
   HS3%=BB%[WL%+2]
   H1%=HS1% XOR HS2% XOR HS3%
   INC P%
   INC PL%,8:IF PL%>=BIT% THEN
    INC PH%:PL%=0
    IF PH%<LEN_IN% THEN Q%=IN%[PH%] ELSE Q%=0
   ENDIF
   INC I%
  UNTIL I%>=MLL%
 WEND
 IF OL%>0 THEN PUSH OUT%,O%
 IF PROG% THEN LOCATE OUT CSRX,CSRY:LOCATE 0,CSRY-1:PRINT "*"*40
END

DEF UNLZ IN%[],INOFS%,OUT%[],WLB%,MLB%,BIT%,PROG%
 VAR J%=0,C%,L%,D%,B%,P%
 VAR OL%=0,O%=0,K%,I%
 VAR WL%=(1<<WLB%)-1
 VAR ML%=(1<<MLB%)-1
 VAR LEN_IN%=LEN(IN%)
 VAR CNT%=0,PRG1%
 DIM BB%[WL%+1]
 VAR BBI%=0
 IF PROG% THEN
  PRG1%=INOFS%*40/LEN_IN%
  PRINT "*"*PRG1%+"-"*(40-PRG1%)
 ENDIF
 
 P%=IN%[INOFS%]
 WHILE INOFS%<LEN_IN%
  IF PROG% THEN
   INC CNT%
   IF CNT%>16 THEN
    CNT%=0
    PRG1%=INOFS%*40/LEN_IN%
    LOCATE OUT CSRX,CSRY
    LOCATE 0,CSRY-1
    PRINT "*"*PRG1%+"-"*(40-PRG1%)
   ENDIF
  ENDIF
  C%=(P%>>J%) AND 1
  INC J%
  IF J%>=32 THEN
   INC INOFS%:DEC J%,32
   IF INOFS%>=LEN_IN% THEN BREAK
   P%=IN%[INOFS%]
  ENDIF
  
  IF C%==0 THEN
   B%=(P%>>J%) AND 255
   INC J%,8
   IF J%>=32 THEN
    INC INOFS%:DEC J%,32
    B%= B% AND ((1<<(8-J%))-1)
    IF INOFS%<LEN_IN% THEN
     P%=IN%[INOFS%]
     B%=(B% OR (P%<<(8-J%))) AND 255
    ENDIF
   ENDIF
   O%=O% OR (B%<<OL%)
   BB%[BBI%]=B%
   INC BBI%:IF BBI%>WL% THEN BBI%=0
   INC OL%,8
   IF OL%>=BIT% THEN PUSH OUT%,O%:OL%=0:O%=0
  ELSE
   D%=((P%>>J%) AND WL%)
   INC J%,WLB%
   IF J%>=32 THEN
    INC INOFS%:DEC J%,32:P%=IN%[INOFS%]
    D%= D% AND ((1<<(WLB%-J%))-1)
    D%=(D% OR (P%<<(WLB%-J%))) AND WL%
   ENDIF
   L%=((P%>>J%) AND ML%)
   INC J%,MLB%
   IF J%>=32 THEN
    INC INOFS%:DEC J%,32
    L%= L% AND ((1<<(MLB%-J%))-1)
    IF INOFS%<LEN_IN% THEN
     P%=IN%[INOFS%]
     L%=(L% OR (P%<<(MLB%-J%))) AND ML%
    ENDIF
   ENDIF
   L%=L%+1
   K%=WL%-D%+BBI%
   IF K%>WL% THEN DEC K%,WL%+1
   FOR I%=1 TO L%
    B%=BB%[K%]
    O%=O% OR (B%<<OL%)
    BB%[BBI%]=B%
    INC BBI%:IF BBI%>WL% THEN BBI%=0
    INC K%:IF K%>WL% THEN K%=0
    INC OL%,8
    IF OL%>=BIT% THEN PUSH OUT%,O%:OL%=0:O%=0
   NEXT
  ENDIF
 WEND
 IF PROG% THEN LOCATE OUT CSRX,CSRY:LOCATE 0,CSRY-1:PRINT "*"*40
END

DEF CALC_CRCTBL()
 DIM T%[256]
 VAR I%,J%,K%
 FOR I%=0 TO 255
  K%=I%
  FOR J%=0 TO 7
   IF (K%AND 1)==1 THEN
    K%=(&HC7ED XOR (K%>>1))
   ELSE
    K%=K%>>1
   ENDIF
  NEXT
  T%[I%]=K%
 NEXT
 RETURN T%
END

DEF CALC_CRC(C%,TBL%[],B%)
 RETURN(TBL%[(C% XOR B%)AND&HFF]XOR(C%>>8))
END
